Player p; //  eine Variable, die die Spielerklasse darstellt
Platform [] platforms; // Array für mehrere Plattformen

PImage [] spriteImages; // 24 Bilder zur Animation des Sprites (Hauptfigur)
int frames; // frame = ein Frame der Animation

boolean left, right, up, down, space; // booleans, während die Taste gehalten werden kann, um das Zeichen zu bewegen

FrameObject camera, gameWorld; // camera = was wir auf dem Bildschirm sehen, gameworld = die Größe des gesamten Levels
ImageObject backImage; // Hintergrund
PImage background; // wird in backObject gesetzt

boolean loadGame, instGame, winGame, loseGame, playGame; // verantwortlich für das Ändern der Spielbildschirme

boolean pwon, pdead; // Zustände des Spielers, um das Spiel mit Gewinn- und Verlustmechanismen auszustatten

import processing.sound.*; // Importieren der Soundbibliothek

SoundFile file; 

//------------------------------------SETUP-------------------------------------------------

void setup() {
  
frameRate (200); //Damit das Spiel schneller wird, es gibt viele Daten und es ist ziemlich langsam
  
  
 loadGame = true; // Das Spiel beginnt beim Ladebildschirm
 instGame = false; // Spielanleitung
 winGame = false; // "Sie haben gewonnen"-Bildschirm
 loseGame = false; // "Sie haben verloren"-Bildschirm
 playGame = false; // spielbildschirm
 
 //----------------------------------SOUND-------------------------------------
 
 String audioName = "kalinka.mp3"; 
String path;
path = sketchPath("kalinka.mp3");
file = new SoundFile(this,"kalinka.mp3");
file.loop();
 

 size(1800, 1200);

  left = false;// keine Bewegung am Anfang, booleans nicht true bis keyPressed => siehe keyPressed Block am Ende
  right = false;
  up = false;
  down = false;
  space = false;
   
 background = loadImage("background61.png");
  backImage = new ImageObject(0, 0, 1800, 1200,  background);
  gameWorld = new FrameObject(0, 0, backImage.w*2, backImage.h); // Die Spielwelt ist doppelt so lang wie der Bildschirm
  camera = new FrameObject(0, 0, width, height);

  camera.x = (gameWorld.x + gameWorld.w/2) - camera.w/2; // Kamera "sieht" nur das, was auf den Bildschirm passt: die halbe Spielwelt
  camera.y = (gameWorld.y + gameWorld.h/2) - camera.h/2;


  //----------------------------PLAYER VALUES---------------------------------------------------
  p = new Player();
  frames = 24;
  spriteImages = new PImage[frames]; // Array für alle Frames
  for (int i = 0; i<frames; i++) { //Frames beginnen mit player0001 und gehen nacheinander bis player0024
    spriteImages[i]=loadImage("player"+nf(i+1, 4)+".png");
  }

  platforms = new Platform[12]; // verschiedene Plattformen des Levels
  platforms[0] = new Platform (2, 1000, 200, 50, "safe");
  platforms[1] = new Platform (250, 800, 200, 50, "safe");
  platforms[2] = new Platform (550, 900, 400, 50, "safe");
  platforms[3] = new Platform (1000, 340, 200, 50, "safe");
  platforms[4] = new Platform (824, 660, 200, 50, "safe");
  platforms[5] = new Platform (1324, 840, 200, 50, "safe");
  platforms[7] = new Platform (1724, 940, 200, 50, "safe");
  platforms[8] = new Platform (2100, 640, 420, 50, "safe");
  platforms[9] = new Platform (2500, 340, 200, 50, "safe");
  platforms[10] = new Platform (2900, 700, 200, 50, "safe");
  platforms[11] = new Platform (3300, 600, 300, 50, "win");
  platforms[6] = new Platform (0, gameWorld.h-40, gameWorld.w, 50, "death"); // Die Bodenplattform, wenn Sie darauf fallen, werden Sie sterben
}
  

void playGame() {

  background(255);
  p.update();
  for (int i = 0; i < platforms.length; ++i) {
    p.collisionSide = rectangleCollisions(p, platforms[i]);
    if (p.collisionSide != "none" && platforms[i].typeof == "death") { // Wenn der Spieler auf den Boden fällt, stirbt er
      loseGame = true;
    }
    if (p.collisionSide == "bottom" && platforms[i].typeof == "win") { // Wenn man auf die letzte Plattform tritt, gewinnt der Spieler das Spiel
      winGame = true;
    }
      
   
    p.checkPlatforms(); // Überprüfung der Kollisionen mit Plattformen => siehe Tab Player
  }
  if (pdead == true){ // Wenn Sie ein Spiel gewinnen oder verlieren, werden Sie zu den Bildschirmen mit dem Status Verlieren/Gewinn weitergeleitet
       loseGame = true;}
     if (pwon == true){
       winGame = true;}
  //Bewegen die Kamera
  camera.x = floor(p.x + (p.halfWidth) - (camera.w / 2)); // Der Spieler kann sich nicht über die Kamera hinaus bewegen
  camera.y = floor(p.y + (p.halfHeight) - (camera.h / 2));

  //die Kamera innerhalb der gameWorld-Grenzen halten
  if (camera.x < gameWorld.x) {
    camera.x = gameWorld.x;
  }
  if (camera.y < gameWorld.y) {
    camera.y = gameWorld.y;
  }
  if (camera.x + camera.w > gameWorld.x + gameWorld.w) {
    camera.x = gameWorld.x + gameWorld.w - camera.w;
  }
  if (camera.y + camera.h > gameWorld.h) {
    camera.y = gameWorld.h - camera.h;
  }

  pushMatrix();
  translate(-camera.x, -camera.y);

  backImage.display();
  p.display1(); // Anzeige des Spielersr
 
  for (int i = 0; i < platforms.length; ++i) { // Anzeige aller Plattformen
    platforms[i].display();
  
      }
  popMatrix();
  if (winGame == true){winGame(); //Zustand des Gewinnens/Verlierens löst die Funktion aus => siehe screens
  } 
  if (loseGame == true){loseGame();
  }
  if (loseGame == true) {p.reset();
  }

}



void draw() {
 

  
if (loadGame == true){loadgame(); //Zustand des Ladens/Einblendens der Anweisungen löst die Funktion aus => siehe screens
 }
   if (instGame == true){instGame();
  }
 
   if (playGame == true){playGame();
  }
}

 


    
String rectangleCollisions(Player r1, Platform r2) {
  ////r1 ist der Spieler
  ////r2 ist das Rechteck der Plattform
  ////function liefert den String collisionSide

  //Erlaube dem Spieler, durch Plattformen zu gehen.
  //Deaktivieren, wenn der Spieler von der Unterseite der Plattformen abprallen soll

  if (r1.vy < 0) { 
    return "none";
  }

  float dx = (r1.x+r1.w/2) - (r2.x+r2.w/2);
  float dy = (r1.y+r1.h/2) - (r2.y+r2.h/2);

  float combinedHalfWidths = r1.halfWidth + r2.halfWidth;
  float combinedHalfHeights = r1.halfHeight + r2.halfHeight;

  if (abs(dx) < combinedHalfWidths) {
        ////Kollision auf der x-Achse stattgefunden hat
    ////jetzt auf der y-Achse prüfen
    if (abs(dy) < combinedHalfHeights) {
   ///Kollision erkannt
      //Bestimmen der Überlappung auf jeder Achse
      float overlapX = combinedHalfWidths - abs(dx);
      float overlapY = combinedHalfHeights - abs(dy);
        ////die Kollision erfolgt auf der Achse mit der
      ////KLEINSTEN Überlappung
      if (overlapX >= overlapY) {
        if (dy > 0) {
         ////das Rechteck zurückschieben, um die Überlappung zu beseitigen vor dem Aufruf seiner Anzeige, um zu verhindern, dass Objekte ineinander gezeichnet werden
          r1.y += overlapY;
          return "top";
        } else {
          r1.y -= overlapY;
          return "bottom";
        }
      } else {
        if (dx > 0) {
          r1.x += overlapX;
          return "left";
        } else {
          r1.x -= overlapX;
          return "right";
        }
      }
    } else {
      //Kollision auf der y-Achse fehlgeschlagen
      return "none";
    }
  } else {
    //Kollision an der x-Achse fehlgeschlagen
    return "none";
  }
}

//-----------------------TASTENCODES UND TASTENDRUCK-----------------------------

void keyPressed() {
  switch (keyCode) {
  case 37://left
    left = true;
    break;
  case 39://right
    right = true;
    break;
  case 38://up
    up = true;
    break;
  case 40://down
    down = true;
    break;
  case 32: //space
    space = true;
    break;
  }
}
void keyReleased() {
  switch (keyCode) {
  case 37://left
    left = false;
    break;
  case 39://right
    right = false;
    break;
  case 38://up
    up = false;
    break;
  case 40://down
    down = false;
    break;
  case 32: //space
    space = false;
    break;
  }
}
